	program hydmastbr
	CHARACTER*25 FICHIER(20)
	real wij(100,100,10),wjk(100,100,10),xmin(2,100,10),xmax(2,100,10)
	real x(100),xmod(2,100,10),y(100)
	integer ii(10),jj(10),kk(10)
*       the file "xxxxxx.w" contains neural model parameters:
	fichier(1)="transition.w"
	fichier(2)="el-hir.w"
	fichier(3)="el-lir.w"
	fichier(4)="psil-lir.w"
	fichier(5)="psil-1-hir.w"
	fichier(6)="sherliq.w"
	fichier(7)="shergas.w"
	fichier(8)="adh1-e.w"
	do 75 im=1,8
	open(1,file=fichier(im),status="old")	 
	read(1,*) ii(im),jj(im),kk(im)
	do 10 i=1,ii(im)
	  read(1,*) xmax(1,i,im),xmin(1,i,im),xmod(1,i,im)
10	continue
	do 20 i=1,kk(im)
	  read(1,*) xmax(2,i,im),xmin(2,i,im),xmod(2,i,im)
20	continue
       	do 30 i=1,ii(im)+1
	  read(1,*) (wij(i,j,im),j=1,jj(im))
30        continue
	do 40 j=1,jj(im)+1
	  read(1,*) (wjk(j,k,im),k=1,kk(im))
40        continue
75      continue

*		********************Input data**********************
*     LIQUID PROPERTIES 					

*     density kg/m3
	rol = 1080
*    viscosity kg/m.s
	xmul = .00104
*    surface tension kg/s2
	sigl = .0628
*superficial velocity m/s
	ul = .0019
	 
*   GAS PROPERTIES
*    density kg/m3
	rog = 1.1891
*    viscosity kg/m.s
	xmug = 1.71e-05   
*superficial velocity m/s
	ug =2.    
*    SOLUTE PROPERTIES
*    diffusion coefficient of solute in liquid m2/s            
	dcl = 2.e-09 
* diffusion coefficient of solute in gasm2/s            
      dcg=  1.4e-5
*    PARTICLE AND BED PROPERTIES
*   equivalent grain diameter m
	dv = .0104             
*    sphericity 
	phi =.9
*    porosity 
	eps =.40
*    column diameter m
	dc =.2            
*		simulate   liquid velocity at trickle-pulse flow transition  is y(1)
	i m=1
	x(1)= rol
	x(2)=xmul
	x(3)=sigl
	x(4)=ug
	x(5)=rog
	x(6)=dv
	x(7)=eps
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	ultrans=y(1)	
	write(6,*) im,y(1)

*		simulate liquid retention -  high iteraction
	i m=2
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul/(1-eps)
	reg=rog*dv*ug/xmug/(1-eps)
	webl=ul**2.*dv*rol/sigl
	xg=ug/ul*(rog/rol)**.5
	x(1)=rel
	x(2)=reg
	x(3)=webl
	x(4)=xg
	x(5)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	elhir=y(1)
	write(6,*) im,elhir
*		simulate liquid retention -  low iteraction
	im=3.
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul/(1-eps)
	reg=rog*dv*ug/xmug/(1-eps)
	webl=ul**2.*dv*rol/sigl
	xg=ug/ul*(rog/rol)**.5
	gal=dv**3.*9.81*eps**3.*rol**2./xmul**2./(1-eps)**3. 	 
      x(1)=rel
	x(2)=reg
	x(3)=webl
	x(4)=xg
	x(5)=sb
	x(6)=gal
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	ellir=y(1) 
	write(6,*) im, ellir			
*	  simulate psi-L-LIR
	im=4
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul/(1-eps)
	reg=rog*dv*ug/xmug/(1-eps)
	webl=ul**2.*dv*rol/sigl
	xg=ug/ul*(rog/rol)**.5
	xl=1./xg
	gal=dv**3.*9.81*eps**3.*rol**2./xmul**2./(1-eps)**3. 	 
      x(1)=rel
	x(2)=reg
	x(3)=webl
	x(4)=gal
	x(5)=xl
	x(6)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	psillir=y(1) 
	dpdz=(y(1)-1) *rol*9.81

	write(6,*) im,psillir,dpdz
*	simulate * (psiL -1 )- HIR
	im=5
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul/(1-eps)
	reg=rog*dv*ug/xmug/(1-eps)
	webl=ul**2.*dv*rol/sigl
	xg=ug/ul*(rog/rol)**.5
	gal=dv**3.*9.81*eps**3.*rol**2./xmul**2./(1-eps)**3. 	 
      x(1)=rel
	x(2)=reg
	x(3)=webl
	x(4)=gal
	x(5)=xg
	x(6)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	psilhr=1.+y(1)
	dpdz=y(1) *rol*9.81
	write(6,*) im,psilhr,dpdz
*	 simulate  Liquid Sherwood number
	im=6
 	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
 	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul
	webl=ul**2.*dv*rol/sigl
	xg=ug/ul*(rog/rol)**.5
	gal=dv**3.*9.81*eps**3.*rol**2./xmul**2./(1-eps)**3. 	 
	xmorl=9.81*xmul**4./rol/sigl**3.
	scl=xmul/dcl/rol
      x(1)=rel
	x(2)=webl
	x(3)=xg
	x(4)=xmorl
	x(5)=scl
	x(6)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	sherliq=y(1) 
	write(6,*) im,sherliq
* 
*	 simulate  Gas Sherwood number
	im=7
 	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
 	dh = dv * (16. * eps**3. / 9. / 3.14159 / (1. - eps)**2.)**.3333
	sb = spsa * dh / (1. - eps)
	rel=rol*dv*ul/xmul
	webg=ug**2.*dv*rog/sigl
	xg=ug/ul*(rog/rol)**.5
	scg=xmug/dcg/rog
	stl=xmul*ul/rol/9.81/dv**2.
      x(1)=rel
	x(2)=stl
	x(3)=webg
	x(4)=xg
	x(5)=scg
	x(6)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	shergas=y(1) 
	write(6,*) im,shergas

* 	simulate gas-iquid intrerfacial area:   a.dh/(1-eps) = adh1me
      im=8
	rel = dv * rol * ul / xmul
	reg = dv * rog * ug / xmug
	webl=ul**2.*dv*rol/sigl
	xg=ug*rog**0.5/(ul*rol**0.5)
	eotv=rol*9.81*(dv*phi*eps/(1-eps))**2./sigl
	frl=ul**2./9.81/dv
	spsa = 6. * (1. - eps) / phi / dv + 4. / dc
	dh = dv * (16. * eps**3. / 9. / 3.14 / (1. - eps)**2.)**(1./3.)
	sb = spsa * dh / (1. - eps)
	x(1)= rel
	x(2)=reg
	x(3)=webl
	x(4)=frl
	x(5)=xg
	x(6)=eotv
	x(7)=sb
	call fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	adh1me=y(1) 
	a=adh1me*(1-eps)/dh
	write(6,*) im,adh1me,a
	end
	
*		CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 	subroutine fctreso(ii,jj,kk,wij,wjk,xmax,xmin,xmod,x,y,im)
	real wij(100,100,10),wjk(100,100,10),xmin(2,100,10),xmax(2,100,10)
	real x(100),xmod(2,100,10),y(100),u(100),s(100),h(100)
	integer ii(10),jj(10),kk(10)	
*       neural network equations:
	  do 100 i=1,ii(im)
	  if (xmod(1,i,im).eq.0.) then
	    u(i)=(x(i)-xmin(1,i,im))/(xmax(1,i,im)-xmin(1,i,im))
	  else
	    u(i)=(log10(x(i))-xmin(1,i,im))/(xmax(1,i,im)-xmin(1,i,im))
	  endif
100       continue
	  u(ii(im)+1)=1.
          do 110 j=1,jj(im)
            h(j)=0.
            do 120 i=1,ii(im)+1
120         h(j)=h(j)+wij(i,j,im)*u(i)
110       h(j)=1./(1.+exp(-h(j)))
          h(jj(im)+1)=1.
          do 130 k=1,kk(im)
            s(k)=0.
            do 140 j=1,jj(im)+1
140         s(k)=s(k)+wjk(j,k,im)*h(j)
          s(k)=1./(1.+exp(-s(k)))
          y(k)=xmin(2,k,im)+s(k)*(xmax(2,k,im)-xmin(2,k,im))
          if(xmod(2,k,im).eq.1.) then
            y(k)=10.**(y(k))
          endif
130       continue 
	  return
         end